summaryrefslogtreecommitdiff
path: root/tests.branching
diff options
context:
space:
mode:
authorRichard Maw <richard.maw@codethink.co.uk>2013-03-07 13:20:38 +0000
committerRichard Maw <richard.maw@codethink.co.uk>2013-03-07 13:20:38 +0000
commit0c26cb74e830c4afb67104c4f26c9a162b2145ff (patch)
treeb92678a8385f18dad31f19f2475349a5e9c505f8 /tests.branching
parentc11cdb16e2d10e29c96873db5796e911979012d8 (diff)
downloadmorph-0c26cb74e830c4afb67104c4f26c9a162b2145ff.tar.gz
Add test for adding a chunk then editing it
This works sub-optimally, `morph edit $system $stratum` needs to be done first as `morph edit $system $stratum $chunk` fails if $chunk is not defined in the parent branch.
Diffstat (limited to 'tests.branching')
-rwxr-xr-xtests.branching/add-then-edit.script61
-rwxr-xr-xtests.branching/add-then-edit.setup40
-rw-r--r--tests.branching/add-then-edit.stdout1
3 files changed, 102 insertions, 0 deletions
diff --git a/tests.branching/add-then-edit.script b/tests.branching/add-then-edit.script
new file mode 100755
index 00000000..40ee7161
--- /dev/null
+++ b/tests.branching/add-then-edit.script
@@ -0,0 +1,61 @@
+#!/bin/sh
+#
+# Copyright (C) 2013 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+## Test the workflow of adding a new chunk to a stratum then editing it
+
+set -eu
+
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" init
+"$SRCDIR/scripts/test-morph" branch test:morphs "me/add-then-edit"
+
+cd "me/add-then-edit"
+
+# add a chunk
+cd test:morphs
+
+## Sub-optimally, to alter the stratum, you have to `morph edit` it first
+"$SRCDIR/scripts/test-morph" edit hello-system hello-stratum
+
+git apply <<'EOF'
+diff --git a/hello-stratum.morph b/hello-stratum.morph
+index 3b7be17..c79a9af 100644
+--- a/hello-stratum.morph
++++ b/hello-stratum.morph
+@@ -7,6 +7,12 @@
+ "repo": "test:hello",
+ "ref": "master",
+ "build-depends": []
++ },
++ {
++ "name": "goodbye",
++ "repo": "test:goodbye",
++ "ref": "master",
++ "build-depends": []
+ }
+ ]
+ }
+EOF
+
+"$SRCDIR/scripts/test-morph" edit hello-system hello-stratum goodbye
+
+# check whether the stratum still contains the goodbye chunk
+grep -qFe goodbye hello-stratum.morph
+
+# check whether edit has cloned the repository to the right branch
+git --git-dir="../test:goodbye/.git" rev-parse --abbrev-ref HEAD
diff --git a/tests.branching/add-then-edit.setup b/tests.branching/add-then-edit.setup
new file mode 100755
index 00000000..7dbe28c0
--- /dev/null
+++ b/tests.branching/add-then-edit.setup
@@ -0,0 +1,40 @@
+#!/bin/sh
+# Copyright (C) 2013 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+# Create goodbye chunk
+mkdir "$DATADIR/goodbye"
+cd "$DATADIR/goodbye"
+
+cat >goodbye <<'EOF'
+#!/bin/sh
+echo goodbye
+EOF
+chmod +x goodbye
+
+cat >goodbye.morph <<'EOF'
+{
+ "name": "goodbye",
+ "kind": "chunk",
+ "install-commands": [
+ "install goodbye \"$DESTDIR$PREFIX/bin/goodbye\""
+ ]
+}
+EOF
+git init .
+git add goodbye.morph goodbye
+git commit -m "Initial commit"
diff --git a/tests.branching/add-then-edit.stdout b/tests.branching/add-then-edit.stdout
new file mode 100644
index 00000000..e0950ab5
--- /dev/null
+++ b/tests.branching/add-then-edit.stdout
@@ -0,0 +1 @@
+me/add-then-edit